// FontMake.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <ostream.h>
#include <windows.h>

COLORREF CLR_WHITE=RGB(255,255,255);
COLORREF CLR_LTGRAY=RGB(192,192,192);
COLORREF CLR_DKGRAY=RGB(128,128,128);
COLORREF CLR_BLACK=RGB(0,0,0);
COLORREF CLR_TRANSPARENT=RGB(255,0,255);

//main bitmap
HDC hdcMain;
HBITMAP hbmMain;
HBITMAP hbmMainOld;
BITMAP bmpMain;
HDC hdc;

//column/row breaks.
int* iColumnBreaks;
int* iRowBreaks;
int iColumns;
int iRows;
int cellcount;

//column/row
int iColumn;
int iRow;

//bitmap sequence size
int imaxwidth;
int imaxheight;

//cell scanning
int imaxx;
int imaxy;
int iminx;
int iminy;

//cells
int cellx;
int celly;
int cellwidth;
int cellheight;

//scan
int scanwidth;

//misc
int tempx;
int tempy;
int pely;
int pelx;
int bytex;
COLORREF pel;

//buffer
int bufsize;
UCHAR* buf;
int bufpos;

int main(int argc, char* argv[])
{
	hdc=GetDC(NULL);

	cout<<argv[1]<<endl;
	cout<<argv[2]<<endl;

	cout<<"Creating Main Bitmap"<<endl;
	//load in the bitmap
	hdcMain=CreateCompatibleDC(NULL);//create a memory dc
	hbmMain=(HBITMAP)LoadImage(NULL,argv[1],IMAGE_BITMAP,0,0,LR_LOADFROMFILE);//load in image
	hbmMainOld=(HBITMAP)SelectObject(hdcMain,hbmMain);//select image into dc
	GetObject(hbmMain,sizeof(BITMAP),&bmpMain);//grab statistics about image
	CLR_TRANSPARENT=GetPixel(hdcMain,bmpMain.bmWidth-1,0);
	CLR_BLACK=GetPixel(hdcMain,bmpMain.bmWidth-1,1);
	CLR_DKGRAY=GetPixel(hdcMain,bmpMain.bmWidth-1,2);
	CLR_LTGRAY=GetPixel(hdcMain,bmpMain.bmWidth-1,3);
	CLR_WHITE=GetPixel(hdcMain,bmpMain.bmWidth-1,4);

	cout<<"counting columns"<<endl;
	//count the columns
	iColumns=0;
	for(tempx=0;tempx<bmpMain.bmWidth;tempx++)
	{
		//check for column break
		if(GetPixel(hdcMain,tempx,0)==CLR_TRANSPARENT)
		{
			//increase number of columns
			iColumns++;
		}
	}
	//allocate column break list
	iColumnBreaks=new int[iColumns];
	iColumns=0;
	for(tempx=0;tempx<bmpMain.bmWidth;tempx++)
	{
		//check for column break
		if(GetPixel(hdcMain,tempx,0)==CLR_TRANSPARENT)
		{
			//save this position
			iColumnBreaks[iColumns]=tempx;
			//increase number of columns
			iColumns++;
		}
	}
	//decrease column count by one
	iColumns--;
	cout<<(iColumns)<<" columns"<<endl;

	cout<<"counting rows"<<endl;
	//count the rows
	iRows=0;
	for(tempy=0;tempy<bmpMain.bmHeight;tempy++)
	{
		//check for a row break
		if(GetPixel(hdcMain,0,tempy)==CLR_TRANSPARENT)
		{
			//increase number of rows
			iRows++;
		}
	}
	iRowBreaks=new int[iRows];
	iRows=0;
	for(tempy=0;tempy<bmpMain.bmHeight;tempy++)
	{
		//check for a row break
		if(GetPixel(hdcMain,0,tempy)==CLR_TRANSPARENT)
		{
			//save this position
			iRowBreaks[iRows]=tempy;
			//increase number of rows
			iRows++;
		}
	}
	iRows--;
	cout<<iRows<<" rows"<<endl;

	//calculate number of cells
	cellcount=iColumns*iRows;
	cout<<cellcount<<" cells"<<endl;

	//determine max height
	imaxheight=0;
	for(iRow=0;iRow<iRows;iRow++)
	{
		cellheight=iRowBreaks[iRow+1]-iRowBreaks[iRow]-1;
		if(cellheight>imaxheight) imaxheight=cellheight;
	}
	cout<<imaxheight<<" is the max height"<<endl;

	//determine max width
	imaxwidth=0;
	for(iColumn=0;iColumn<iColumns;iColumn++)
	{
		cellwidth=iColumnBreaks[iColumn+1]-iColumnBreaks[iColumn]-1;
		if(cellwidth>imaxwidth) imaxwidth=cellwidth;
	}
	cout<<imaxwidth<<" is the max width"<<endl;

	bufsize=4;//set initial size of buffer

	//scan the cells for size
	for(iRow=0;iRow<iRows;iRow++)
	{
		for(iColumn=0;iColumn<iColumns;iColumn++)
		{
			bufsize+=4;//add bitmap header

			cellwidth=iColumnBreaks[iColumn+1]-iColumnBreaks[iColumn]-1;
			cellheight=iRowBreaks[iRow+1]-iRowBreaks[iRow]-1;

			imaxx=-1;
			imaxy=-1;
			iminx=cellwidth;
			iminy=cellheight;
			for(tempy=0;tempy<cellheight;tempy++)
			{
				for(tempx=0;tempx<cellwidth;tempx++)
				{
					if(GetPixel(hdcMain,iColumnBreaks[iColumn]+1+tempx,iRowBreaks[iRow]+1+tempy)!=CLR_TRANSPARENT)
					{
						if(tempx>imaxx) imaxx=tempx;
						if(tempx<iminx) iminx=tempx;
						if(tempy>imaxy) imaxy=tempy;
						if(tempy<iminy) iminy=tempy;
					}
				}
			}

			cellwidth=imaxx-iminx+1;
			cellheight=imaxy-iminy+1;
			scanwidth=(cellwidth+3)/4;

			bufsize+=(scanwidth*cellheight);//add to buffer


		}
	}

	//allocate buffer
	buf=new UCHAR[bufsize];
	bufpos=0;

	//write to the buffer
	buf[bufpos++]=0x02;
	buf[bufpos++]=cellcount;
	buf[bufpos++]=imaxwidth;
	buf[bufpos++]=imaxheight;


	for(iRow=0;iRow<iRows;iRow++)
	{
		for(iColumn=0;iColumn<iColumns;iColumn++)
		{
			cellwidth=iColumnBreaks[iColumn+1]-iColumnBreaks[iColumn]-1;
			cellheight=iRowBreaks[iRow+1]-iRowBreaks[iRow]-1;

			cout<<"Cell #"<<(iColumn+iRow*iColumns)<<":"<<endl;

			//create cell bitmap
			
			imaxx=-1;
			imaxy=-1;
			iminx=cellwidth;
			iminy=cellheight;
			for(tempy=0;tempy<cellheight;tempy++)
			{
				for(tempx=0;tempx<cellwidth;tempx++)
				{
					if(GetPixel(hdcMain,iColumnBreaks[iColumn]+1+tempx,iRowBreaks[iRow]+1+tempy)!=CLR_TRANSPARENT)
					{
						if(tempx>imaxx) imaxx=tempx;
						if(tempx<iminx) iminx=tempx;
						if(tempy>imaxy) imaxy=tempy;
						if(tempy<iminy) iminy=tempy;
					}
				}
			}

			cout<<"minx="<<iminx<<endl;
			cout<<"miny="<<iminy<<endl;
			cout<<"maxx="<<imaxx<<endl;
			cout<<"maxy="<<imaxy<<endl;

			cellwidth=imaxx-iminx+1;
			cellheight=imaxy-iminy+1;
			scanwidth=(cellwidth+3)/4;

			buf[bufpos++]=iminx;
			buf[bufpos++]=iminy;
			buf[bufpos++]=cellwidth;
			buf[bufpos++]=cellheight;


			for(pely=0;pely<cellheight;pely++)
			{
				for(bytex=0;bytex<(scanwidth);bytex++)
				{
					buf[bufpos]=0;
					for(pelx=0;pelx<4;pelx++)
					{
						pel=CLR_WHITE;
						if((bytex*4+pelx)<cellwidth) pel=GetPixel(hdcMain,iColumnBreaks[iColumn]+1+iminx+bytex*4+pelx,iRowBreaks[iRow]+1+iminy+pely);
						if(pel==CLR_BLACK)
						{
								cout<<"3";
								buf[bufpos]|=(3<<(6-pelx*2));
						}
						else if (pel==CLR_DKGRAY)
						{
								cout<<"2";
								buf[bufpos]|=(2<<(6-pelx*2));
						}
						else if (pel==CLR_LTGRAY)
						{
								cout<<"1";
								buf[bufpos]|=(1<<(6-pelx*2));
						}
						else if (pel==CLR_WHITE)
						{
								cout<<"0";
						}
						else
						{
							cout<<"X";
						}
					}
					bufpos++;
				}
				cout<<endl;
			}

		}
	}

	HANDLE hFile;
	DWORD dwNumWritten;

	//write buffer to disk
	hFile=CreateFile(argv[2],GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	WriteFile(hFile,buf,bufsize,&dwNumWritten,NULL);
	CloseHandle(hFile);

	//delete the buffer
	delete [] buf;

	//clean up row and column breaks
	delete [] iRowBreaks;
	delete [] iColumnBreaks;

	//clean up main bitmap
	SelectObject(hdcMain,hbmMainOld);//reselect old bitmap into dc
	DeleteObject(hbmMain);//delete main bitmap
	DeleteDC(hdcMain);//delete main dc

	ReleaseDC(NULL,hdc);

	return(0);
}

